Subject: Re: [PATCH] net: qualcomm: rmnet: Allow partial updates of IFLA_FLAGS

From: Bjorn Andersson <[email-masked]>
Date: Thu, 22 Apr 2021 21:30:26 -0500

On Thu 22 Apr 18:28 CDT 2021, [email-masked] wrote:

> On 2021-04-22 12:29, Alex Elder wrote:
> > On 4/22/21 1:20 PM, Bjorn Andersson wrote:
> > > The idiomatic way to handle the changelink flags/mask pair seems to be
> > > allow partial updates of the driver's link flags. In contrast the
> > > rmnet
> > > driver masks the incoming flags and then use that as the new flags.
> > > 
> > > Change the rmnet driver to follow the common scheme, before the
> > > introduction of IFLA_RMNET_FLAGS handling in iproute2 et al.
> > 
> > I like this a lot.  It should have been implemented this way
> > to begin with; there's not much point to have the mask if
> > it's only applied to the passed-in value.
> > 
> > KS, are you aware of *any* existing user space code that
> > would not work correctly if this were accepted?
> > 
> > I.e., the way it was (is), the value passed in *assigns*
> > the data format flags.  But with Bjorn's changes, the
> > data format flags would be *updated* (i.e., any bits not
> > set in the mask field would remain with their previous
> > value).
> > 
> > Reviewed-by: Alex Elder <[email-masked]>
> 
> What rmnet functionality which was broken without this change.
> That doesnt seem to be listed in this patch commit text.
> 

I recently posted a patch to iproute2 extending the rmnet link handling
to handle IFLA_RMNET_FLAGS, in the discussion that followed this subject
came up. So nothing is broken, it's just that the current logic doesn't
make sense and I wanted to attempt to fix it before we start to use it
commonly distributed userspace software (iproute2, libqmi etc)

> If this is an enhancement, then patch needs to be targeted to net-next
> instead of net

Okay, please let me know what hoops you want me to jump through. I just
want the subject concluded so that I can respin my iproute2 patch
according to what we decide here.

Regards,
Bjorn